class BoundedHash
    
  def initialize(size_limit)
    @size_limit = size_limit
    @values = Hash.new # stores user-supplied mappings
    @next_entry_id = 0
    @entries = Hash.new # maps entry ids to keys. lower ids = older keys.
    self
  end
  
  def [] (k)
    @values[k]
  end
  
  def []= (k, v)
    @values[k] = v
    @entries[@next_entry_id += 1] = k
    ensure_bounds
    self
  end
  
  def ensure_bounds
    while @values.length > @size_limit do
      i = @entries.keys.min
      @values.delete(@entries[i])
      @entries.delete(i)
    end
  end
  
end

# a=BoundedHash.new 2
# a[1]=1
# a[1]==1
# a[2]=2
# a[2]==2
# a[1]==1
# a[3]=3
# a[3]==3
# a[2]==2
# a[1]==Hash.new()[1]
